class MyApp : public App {

protected:
public:

    MyApp(int w, int h, const char* title = "OpenGL SDL2 Demo") : App(w, h, title) { };

    // Обработка движения
    void doControl() {

        vec3 move = {0, 0, 0};
        vec3 look = lookCamera();

        // Обработка движений
        if (pressed(SDL_SCANCODE_W)) { move.x += look.x; move.z += look.z; }
        if (pressed(SDL_SCANCODE_S)) { move.x -= look.x; move.z -= look.z; }
        if (pressed(SDL_SCANCODE_A)) { move.x -= look.z; move.z += look.x; }
        if (pressed(SDL_SCANCODE_D)) { move.x += look.z; move.z -= look.x; }

        // Равномерное движение через нормализацию общего вектора
        moveCamera(normalize(move, 0.1));
        updateCamera();
    }

    // Отрисовка сцены
    void render() {

        uniform1f(program_id_latest, "utime", SDL_GetTicks() / 1000.);

        glLoadIdentity();
        glBegin(GL_POLYGON);
        glTexCoord2f(0.0, 0.0);  glVertex3f(-1.0,  1.0, -1.0);
        glTexCoord2f(1.0, 0.0);  glVertex3f( 1.0,  1.0, -1.0);
        glTexCoord2f(1.0, 1.0);  glVertex3f( 1.0, -1.0, -1.0);
        glTexCoord2f(0.0, 1.0);  glVertex3f(-1.0, -1.0, -1.0);
        glEnd();
    }

};
